#!/usr/bin/perl

#(c) Copyright Rosetta Commons Member Institutions.
#(c) This file is part of the Rosetta software suite and is made available under license.
#(c) The Rosetta software is developed by the contributing members of the Rosetta Commons.
#(c) For more information, see http://www.rosettacommons.org. Questions about this can be
#(c) addressed to University of Washington UW TechTransfer, email: license@u.washington.edu.

# author: JKLeman (julia.koehler1982@gmail.com)

$spanfile = $ARGV[0]; 	#input
$pdbfile = $ARGV[1]; 	#input
$out = $spanfile.".pml"; #output
$pdb = substr($pdbfile, 0, 4);

$nres = `grep CA $pdbfile | wc -l`;
$color_sol = "blue";
$color_tm = "orange";

if ($#ARGV < 1){
	print "usage: check_spanfile_in_pymol.pl <spanfile> <pdbfile>\n";
}

#print header for pymol
open ( IN, $spanfile ) || die "cannot open ".$spanfile."!\n";
open ( OUT, ">".$out ) || die "cannot open output file".$pdbfile."!\n";
print OUT "delete everything\n";
print OUT "bg white\n";
print OUT "set ray_shadows=0\n";
print OUT "load ".$pdbfile.", ".$pdb."\n";
print OUT "hide everything\n";
print OUT "color ".$color_sol.", ".$pdb."\n";
print OUT "show cartoon, ".$pdb."\n";

#put spans in arrays
while ( $in = <IN> ){
	chomp $in;
	if ( $in !~ /^\w/ ){
		$in =~ s/\s+//;
		@in = split /\s+/, $in;
		push @start, $in[0];
		push @end, $in[1];
	}
}
close IN;

#go through residues, then check with arrays
$i = 0;
foreach $r ( 1..$nres ){
#	print "$r\t$i\t$start[$i]\t$end[$i]\n";
	if ( $r >= $start[$i] and $r <= $end[$i] ){
		print OUT "color ".$color_tm.", resi $r\n";
		if ( $r == $end[$i] ){
			$i++;
		}
	}
}
close OUT;
print "pymol $out &\n";
#system ("pymol $out &");
